// This file is generated by kconfig_compiler from settings_stream.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_STREAM_H
#define SETTINGS_STREAM_H

#include <kglobal.h>
#include <kconfigskeleton.h>
#include <kdebug.h>

class settings_stream : public KConfigSkeleton
{
  public:
    class EnumSingleFileOverwrite
    {
      public:
      enum type { Always, Never, COUNT };
    };
    class EnumSplittedFilesOverwrite
    {
      public:
      enum type { Always, Larger, Never, COUNT };
    };

    settings_stream( KSharedConfig::Ptr config = KGlobal::config() );
    ~settings_stream();

    /**
      Set stream server URL
    */
    void setServerUri( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "serverUri" ) ))
        mServerUri = v;
    }

    /**
      Get stream server URL
    */
    QString serverUri() const
    {
      return mServerUri;
    }

    /**
      Get Item object corresponding to serverUri()
    */
    ItemString *serverUriItem()
    {
      return mServerUriItem;
    }

    /**
      Set name of the stream
    */
    void setInfo_streamName( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "info_streamName" ) ))
        mInfo_streamName = v;
    }

    /**
      Get name of the stream
    */
    QString info_streamName() const
    {
      return mInfo_streamName;
    }

    /**
      Get Item object corresponding to info_streamName()
    */
    ItemString *info_streamNameItem()
    {
      return mInfo_streamNameItem;
    }

    /**
      Set name of the server
    */
    void setInfo_serverName( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "info_serverName" ) ))
        mInfo_serverName = v;
    }

    /**
      Get name of the server
    */
    QString info_serverName() const
    {
      return mInfo_serverName;
    }

    /**
      Get Item object corresponding to info_serverName()
    */
    ItemString *info_serverNameItem()
    {
      return mInfo_serverNameItem;
    }

    /**
      Set bitrate
    */
    void setInfo_bitrate( qint64 v )
    {
      if (v < -2)
      {
        kDebug() << "setInfo_bitrate: value " << v << " is less than the minimum value of -2";
        v = -2;
      }

      if (v > 2147483647)
      {
        kDebug() << "setInfo_bitrate: value " << v << " is greater than the maximum value of 2147483647";
        v = 2147483647;
      }

      if (!isImmutable( QString::fromLatin1( "info_bitrate" ) ))
        mInfo_bitrate = v;
    }

    /**
      Get bitrate
    */
    qint64 info_bitrate() const
    {
      return mInfo_bitrate;
    }

    /**
      Get Item object corresponding to info_bitrate()
    */
    ItemLongLong *info_bitrateItem()
    {
      return mInfo_bitrateItem;
    }

    /**
      Set meta data interval
    */
    void setInfo_metaInterval( qint64 v )
    {
      if (v < -2)
      {
        kDebug() << "setInfo_metaInterval: value " << v << " is less than the minimum value of -2";
        v = -2;
      }

      if (v > 2147483647)
      {
        kDebug() << "setInfo_metaInterval: value " << v << " is greater than the maximum value of 2147483647";
        v = 2147483647;
      }

      if (!isImmutable( QString::fromLatin1( "info_metaInterval" ) ))
        mInfo_metaInterval = v;
    }

    /**
      Get meta data interval
    */
    qint64 info_metaInterval() const
    {
      return mInfo_metaInterval;
    }

    /**
      Get Item object corresponding to info_metaInterval()
    */
    ItemLongLong *info_metaIntervalItem()
    {
      return mInfo_metaIntervalItem;
    }

    /**
      Set timeout when no data is send
    */
    void setAdvanced_useTimeout( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "advanced_useTimeout" ) ))
        mAdvanced_useTimeout = v;
    }

    /**
      Get timeout when no data is send
    */
    bool advanced_useTimeout() const
    {
      return mAdvanced_useTimeout;
    }

    /**
      Get Item object corresponding to advanced_useTimeout()
    */
    ItemBool *advanced_useTimeoutItem()
    {
      return mAdvanced_useTimeoutItem;
    }

    /**
      Set timeout after X seconds
    */
    void setAdvanced_timeoutAfterXSeconds( quint64 v )
    {
      if (v < 1)
      {
        kDebug() << "setAdvanced_timeoutAfterXSeconds: value " << v << " is less than the minimum value of 1";
        v = 1;
      }

      if (v > 32767)
      {
        kDebug() << "setAdvanced_timeoutAfterXSeconds: value " << v << " is greater than the maximum value of 32767";
        v = 32767;
      }

      if (!isImmutable( QString::fromLatin1( "advanced_timeoutAfterXSeconds" ) ))
        mAdvanced_timeoutAfterXSeconds = v;
    }

    /**
      Get timeout after X seconds
    */
    quint64 advanced_timeoutAfterXSeconds() const
    {
      return mAdvanced_timeoutAfterXSeconds;
    }

    /**
      Get Item object corresponding to advanced_timeoutAfterXSeconds()
    */
    ItemULongLong *advanced_timeoutAfterXSecondsItem()
    {
      return mAdvanced_timeoutAfterXSecondsItem;
    }

    /**
      Set reconnect
    */
    void setAdvanced_reconnectAfterDroppedOrTimeout( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "advanced_reconnectAfterDroppedOrTimeout" ) ))
        mAdvanced_reconnectAfterDroppedOrTimeout = v;
    }

    /**
      Get reconnect
    */
    bool advanced_reconnectAfterDroppedOrTimeout() const
    {
      return mAdvanced_reconnectAfterDroppedOrTimeout;
    }

    /**
      Get Item object corresponding to advanced_reconnectAfterDroppedOrTimeout()
    */
    ItemBool *advanced_reconnectAfterDroppedOrTimeoutItem()
    {
      return mAdvanced_reconnectAfterDroppedOrTimeoutItem;
    }

    /**
      Set user agent string
    */
    void setAdvanced_userAgentString( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "advanced_userAgentString" ) ))
        mAdvanced_userAgentString = v;
    }

    /**
      Get user agent string
    */
    QString advanced_userAgentString() const
    {
      return mAdvanced_userAgentString;
    }

    /**
      Get Item object corresponding to advanced_userAgentString()
    */
    ItemString *advanced_userAgentStringItem()
    {
      return mAdvanced_userAgentStringItem;
    }

    /**
      Set offset for metadata in ms
    */
    void setOffset( qint64 v )
    {
      if (v < -32767)
      {
        kDebug() << "setOffset: value " << v << " is less than the minimum value of -32767";
        v = -32767;
      }

      if (v > 32767)
      {
        kDebug() << "setOffset: value " << v << " is greater than the maximum value of 32767";
        v = 32767;
      }

      if (!isImmutable( QString::fromLatin1( "offset" ) ))
        mOffset = v;
    }

    /**
      Get offset for metadata in ms
    */
    qint64 offset() const
    {
      return mOffset;
    }

    /**
      Get Item object corresponding to offset()
    */
    ItemLongLong *offsetItem()
    {
      return mOffsetItem;
    }

    /**
      Set search window for splitpoint detection in ms
    */
    void setSearchWindow( quint64 v )
    {
      if (v < 2)
      {
        kDebug() << "setSearchWindow: value " << v << " is less than the minimum value of 2";
        v = 2;
      }

      if (v > 65534)
      {
        kDebug() << "setSearchWindow: value " << v << " is greater than the maximum value of 65534";
        v = 65534;
      }

      if (!isImmutable( QString::fromLatin1( "searchWindow" ) ))
        mSearchWindow = v;
    }

    /**
      Get search window for splitpoint detection in ms
    */
    quint64 searchWindow() const
    {
      return mSearchWindow;
    }

    /**
      Get Item object corresponding to searchWindow()
    */
    ItemULongLong *searchWindowItem()
    {
      return mSearchWindowItem;
    }

    /**
      Set silence window for splitpoint detection in ms
    */
    void setSilenceWindow( quint64 v )
    {
      if (v < 1)
      {
        kDebug() << "setSilenceWindow: value " << v << " is less than the minimum value of 1";
        v = 1;
      }

      if (v > 32767)
      {
        kDebug() << "setSilenceWindow: value " << v << " is greater than the maximum value of 32767";
        v = 32767;
      }

      if (!isImmutable( QString::fromLatin1( "silenceWindow" ) ))
        mSilenceWindow = v;
    }

    /**
      Get silence window for splitpoint detection in ms
    */
    quint64 silenceWindow() const
    {
      return mSilenceWindow;
    }

    /**
      Get Item object corresponding to silenceWindow()
    */
    ItemULongLong *silenceWindowItem()
    {
      return mSilenceWindowItem;
    }

    /**
      Set write single file
    */
    void setWriteSingleFile( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "writeSingleFile" ) ))
        mWriteSingleFile = v;
    }

    /**
      Get write single file
    */
    bool writeSingleFile() const
    {
      return mWriteSingleFile;
    }

    /**
      Get Item object corresponding to writeSingleFile()
    */
    ItemBool *writeSingleFileItem()
    {
      return mWriteSingleFileItem;
    }

    /**
      Set override existing single file
    */
    void setSingleFileOverwrite( int v )
    {
      if (!isImmutable( QString::fromLatin1( "singleFileOverwrite" ) ))
        mSingleFileOverwrite = v;
    }

    /**
      Get override existing single file
    */
    int singleFileOverwrite() const
    {
      return mSingleFileOverwrite;
    }

    /**
      Get Item object corresponding to singleFileOverwrite()
    */
    ItemEnum *singleFileOverwriteItem()
    {
      return mSingleFileOverwriteItem;
    }

    /**
      Set write splitted files
    */
    void setWriteSplittedFiles( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "writeSplittedFiles" ) ))
        mWriteSplittedFiles = v;
    }

    /**
      Get write splitted files
    */
    bool writeSplittedFiles() const
    {
      return mWriteSplittedFiles;
    }

    /**
      Get Item object corresponding to writeSplittedFiles()
    */
    ItemBool *writeSplittedFilesItem()
    {
      return mWriteSplittedFilesItem;
    }

    /**
      Set truncate duplicates in the 'incomplete' directory to 0 bytes
    */
    void setTruncateDuplicatesInIncomplete( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "truncateDuplicatesInIncomplete" ) ))
        mTruncateDuplicatesInIncomplete = v;
    }

    /**
      Get truncate duplicates in the 'incomplete' directory to 0 bytes
    */
    bool truncateDuplicatesInIncomplete() const
    {
      return mTruncateDuplicatesInIncomplete;
    }

    /**
      Get Item object corresponding to truncateDuplicatesInIncomplete()
    */
    ItemBool *truncateDuplicatesInIncompleteItem()
    {
      return mTruncateDuplicatesInIncompleteItem;
    }

    /**
      Set section of the previous track which is saved also (ms)
    */
    void setSplittedFilesPrepad( quint64 v )
    {

      if (v > 32767)
      {
        kDebug() << "setSplittedFilesPrepad: value " << v << " is greater than the maximum value of 32767";
        v = 32767;
      }

      if (!isImmutable( QString::fromLatin1( "splittedFilesPrepad" ) ))
        mSplittedFilesPrepad = v;
    }

    /**
      Get section of the previous track which is saved also (ms)
    */
    quint64 splittedFilesPrepad() const
    {
      return mSplittedFilesPrepad;
    }

    /**
      Get Item object corresponding to splittedFilesPrepad()
    */
    ItemULongLong *splittedFilesPrepadItem()
    {
      return mSplittedFilesPrepadItem;
    }

    /**
      Set section of the next track which is saved also (ms)
    */
    void setSplittedFilesPostpad( quint64 v )
    {

      if (v > 32767)
      {
        kDebug() << "setSplittedFilesPostpad: value " << v << " is greater than the maximum value of 32767";
        v = 32767;
      }

      if (!isImmutable( QString::fromLatin1( "splittedFilesPostpad" ) ))
        mSplittedFilesPostpad = v;
    }

    /**
      Get section of the next track which is saved also (ms)
    */
    quint64 splittedFilesPostpad() const
    {
      return mSplittedFilesPostpad;
    }

    /**
      Get Item object corresponding to splittedFilesPostpad()
    */
    ItemULongLong *splittedFilesPostpadItem()
    {
      return mSplittedFilesPostpadItem;
    }

    /**
      Set tracks to skip before recording
    */
    void setSkipFirstXTracks( quint64 v )
    {

      if (v > 32767)
      {
        kDebug() << "setSkipFirstXTracks: value " << v << " is greater than the maximum value of 32767";
        v = 32767;
      }

      if (!isImmutable( QString::fromLatin1( "skipFirstXTracks" ) ))
        mSkipFirstXTracks = v;
    }

    /**
      Get tracks to skip before recording
    */
    quint64 skipFirstXTracks() const
    {
      return mSkipFirstXTracks;
    }

    /**
      Get Item object corresponding to skipFirstXTracks()
    */
    ItemULongLong *skipFirstXTracksItem()
    {
      return mSkipFirstXTracksItem;
    }

    /**
      Set Overwrite existing files?
    */
    void setSplittedFilesOverwrite( int v )
    {
      if (!isImmutable( QString::fromLatin1( "splittedFilesOverwrite" ) ))
        mSplittedFilesOverwrite = v;
    }

    /**
      Get Overwrite existing files?
    */
    int splittedFilesOverwrite() const
    {
      return mSplittedFilesOverwrite;
    }

    /**
      Get Item object corresponding to splittedFilesOverwrite()
    */
    ItemEnum *splittedFilesOverwriteItem()
    {
      return mSplittedFilesOverwriteItem;
    }

  protected:

    // connection
    QString mServerUri;
    QString mInfo_streamName;
    QString mInfo_serverName;
    qint64 mInfo_bitrate;
    qint64 mInfo_metaInterval;
    bool mAdvanced_useTimeout;
    quint64 mAdvanced_timeoutAfterXSeconds;
    bool mAdvanced_reconnectAfterDroppedOrTimeout;
    QString mAdvanced_userAgentString;

    // splitting
    qint64 mOffset;
    quint64 mSearchWindow;
    quint64 mSilenceWindow;

    // saving
    bool mWriteSingleFile;
    int mSingleFileOverwrite;
    bool mWriteSplittedFiles;
    bool mTruncateDuplicatesInIncomplete;
    quint64 mSplittedFilesPrepad;
    quint64 mSplittedFilesPostpad;
    quint64 mSkipFirstXTracks;
    int mSplittedFilesOverwrite;

  private:
    ItemString *mServerUriItem;
    ItemString *mInfo_streamNameItem;
    ItemString *mInfo_serverNameItem;
    ItemLongLong *mInfo_bitrateItem;
    ItemLongLong *mInfo_metaIntervalItem;
    ItemBool *mAdvanced_useTimeoutItem;
    ItemULongLong *mAdvanced_timeoutAfterXSecondsItem;
    ItemBool *mAdvanced_reconnectAfterDroppedOrTimeoutItem;
    ItemString *mAdvanced_userAgentStringItem;
    ItemLongLong *mOffsetItem;
    ItemULongLong *mSearchWindowItem;
    ItemULongLong *mSilenceWindowItem;
    ItemBool *mWriteSingleFileItem;
    ItemEnum *mSingleFileOverwriteItem;
    ItemBool *mWriteSplittedFilesItem;
    ItemBool *mTruncateDuplicatesInIncompleteItem;
    ItemULongLong *mSplittedFilesPrepadItem;
    ItemULongLong *mSplittedFilesPostpadItem;
    ItemULongLong *mSkipFirstXTracksItem;
    ItemEnum *mSplittedFilesOverwriteItem;
};

#endif

