/*
    Copyright (C) 2008  Tim Fechtner < urwald at users dot sourceforge dot net >

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License or (at your option) version 3 or any later version
    accepted by the membership of KDE e.V. (or its successor approved
    by the membership of KDE e.V.), which shall act as a proxy
    defined in Section 14 of version 3 of the license.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "settings_general_widget_general.h"
#include "version.h"
#include <QDebug>

settings_general_widget_general::settings_general_widget_general(QWidget *parent)
  : QWidget(parent)
{
  setupUi(this);
  connect(kcfg_streamripperCommand,
          SIGNAL(textChanged(const QString&)),
          &versionInfo,
          SLOT(setStreamripperCommand(const QString&)));
  connect(kcfg_streamripperCommand,
          SIGNAL(textChanged(const QString&)),
          info_usedStreamripperVersion,
          SLOT(clear()));
  connect(&versionInfo,
          SIGNAL(versionNumberDeterminated(const PropertyValue&)),
          this,
          SLOT(displayVersionNumber(const PropertyValue&)));
#ifdef LIBPROXY_FOUND
  connect(kcfg_proxyConfiguration,
          SIGNAL(valueChanged(const int)),
          this,
          SLOT(initializeRadioButtons(const int)));
  connect(radioButton_automatic,
          SIGNAL(toggled(const bool)),
          this,
          SLOT(writeProxyConfig_automatic(const bool)));
#else
  radioButton_manual->setChecked(true);
  radioButton_automatic->setEnabled(false);
#endif
}

#ifdef LIBPROXY_FOUND
void settings_general_widget_general::initializeRadioButtons(const int index)
{
  qDebug() << "test";
  disconnect(kcfg_proxyConfiguration,
             SIGNAL(valueChanged(const int)),
             this,
             SLOT(initializeRadioButtons(const int)));
  if (index == 0) {
    radioButton_automatic->setChecked(true);
  } else {
    radioButton_manual->setChecked(true);
  };
}
#endif

settings_general_widget_general::~settings_general_widget_general()
{
}

void settings_general_widget_general::writeProxyConfig_automatic(const bool enabled)
{
  if (enabled) { // configuration: automatic
    kcfg_proxyConfiguration->setValue(0);
  } else { // configuration: manual
    kcfg_proxyConfiguration->setValue(1);
  };
}

void settings_general_widget_general::displayVersionNumber(const PropertyValue & value)
{
  if (value.type == PropertyValue::value) {
    info_usedStreamripperVersion->setText(value.formatedValue);
  } else {
    info_usedStreamripperVersion->setText("");
  };
}
