/*
    Copyright (C) 2008  Tim Fechtner < urwald at users dot sourceforge dot net >

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License or (at your option) version 3 or any later version
    accepted by the membership of KDE e.V. (or its successor approved
    by the membership of KDE e.V.), which shall act as a proxy
    defined in Section 14 of version 3 of the license.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "settings_general_widget_saving.h"

settings_general_widget_saving::settings_general_widget_saving(QWidget *parent)
  : QStackedWidget(parent)
{
  setupUi(this);
  saveDirectory->setMode(KFile::Directory | KFile::LocalOnly | KFile::ExistingOnly);
  connect(kcfg_saveDirectory,
          SIGNAL(textChanged(const QString &)),
          this,
          SLOT(setDownloadDirAndEnableKCFG(const QString &)));
}

settings_general_widget_saving::~settings_general_widget_saving()
{
}

void settings_general_widget_saving::setDownloadDirAndEnableKCFG(const QString & downloadDirectory)
{
  disconnect(kcfg_saveDirectory,
             SIGNAL(textChanged(const QString &)),
             this,
             SLOT(setDownloadDirAndEnableKCFG(const QString &)));
  saveDirectory->setUrl(downloadDirectory);
  connect(saveDirectory,
          SIGNAL(textChanged(const QString &)),
          kcfg_saveDirectory,
          SLOT(setText(const QString &)));
}
